public class SierpinskiTurtle extends Turtle {
  //////////////
  // useful methods inherited from Turtle:
  //
  ///** Draw an equilateral triangle with top corner at current pen position
  //    * with side length s. */
  //  public void drawTriangle(double s)
  
  ///** Move the turtle to (x,y), without drawing,
  //      and face it at angle ang. */
  //  public void moveTo(double x, double y, double ang)
  
  
  /** draw a sierpinski triangle with the top point
    * at the turtle's current location */
  public void drawSierpinski(double sideLength, int depth) {
    if (depth == 0) { 
      drawTriangle(sideLength);
      return;
    }
    double startX= getX();
    double startY= getY();

    // top subtriangle
    drawSierpinski(sideLength/2, depth-1);
    // bottom left subtriangle
    moveTo(startX - sideLength/4, startY + sideLength * Math.sqrt(3)/4, getAngle());
    drawSierpinski(sideLength/2, depth-1);
    // bottom right subtriangle
    moveTo(startX + sideLength/4, startY + sideLength * Math.sqrt(3)/4, getAngle());
    drawSierpinski(sideLength/2, depth-1);
    // move back to original location
    moveTo(startX, startY, getAngle());
  }
  
  
  public static void main(String[] args) {
    SierpinskiTurtle t= new SierpinskiTurtle();
    t.addAngle(90);
    t.liftPen();
    t.move(200);
    t.putPenDown();
    
    t.drawSierpinski(400, 3);
  }
}